--beginvalidatingquery
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_DatabaseVersion]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
    begin
        declare @ver int
        exec @ver=sp_DatabaseVersion
        if (@ver >= 8015)
            select 0, 'Already correct database version'
        else if (@ver = 8014)
            select 1, 'Upgrading database'
        else
            select -1, 'Invalid database version detected'
    end
else
    select -1, 'Not an EPiServer database'
--endvalidatingquery
GO

PRINT N'Altering Procedure [dbo].[netProjectList]...';
GO

ALTER PROCEDURE [dbo].[netProjectList]
    @StartIndex INT = 0,
    @MaxRows INT,
    @Status INT = -1
AS
BEGIN
	SET NOCOUNT ON;
	DECLARE @projectIDs TABLE(projectID INT, TotalRows INT);

	WITH PageCTE AS
    (SELECT pkID, [Status],
     ROW_NUMBER() OVER(ORDER BY Name ASC, pkID ASC) AS intRow
     FROM tblProject
	 WHERE @Status  = -1 OR @Status = [Status])

	INSERT INTO @projectIDs
		SELECT NULL AS pkID, COUNT(*) AS TotalRows
		FROM PageCTE
	    UNION
		SELECT PageCTE.pkID, NULL
		FROM PageCTE
		WHERE intRow BETWEEN (@StartIndex +1) AND (@MaxRows + @StartIndex)

	--Projects
	SELECT
		pkID, Name, IsPublic, CreatedBy, Created, [Status], DelayPublishUntil, PublishingTrackingToken, Alias, [Source], Saved
	FROM
		tblProject
	INNER JOIN @projectIDs AS projects ON projects.projectID = tblProject.pkID


	--ProjectMembers
	SELECT
		pkID, projectID, Name, Type
	FROM
		tblProjectMember
	INNER JOIN @projectIDs AS projects ON projects.projectID = tblProjectMember.fkProjectID
	ORDER BY projectID, Name

	RETURN COALESCE((SELECT TOP 1 TotalRows FROM @projectIDs WHERE TotalRows IS NOT NULL), 0)

END
GO


PRINT N'Altering Procedure [dbo].[sp_DatabaseVersion]...';
GO

ALTER PROCEDURE [dbo].[sp_DatabaseVersion]
AS
    RETURN 8015
GO

PRINT N'Update complete.';
GO
