--beginvalidatingquery
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_DatabaseVersion]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
    begin
        declare @ver int
        exec @ver=sp_DatabaseVersion
        if (@ver >= 8018)
            select 0, 'Already correct database version'
        else if (@ver = 8017)
            select 1, 'Upgrading database'
        else
            select -1, 'Invalid database version detected'
    end
else
    select -1, 'Not an EPiServer database'
--endvalidatingquery
GO


GO
PRINT N'Altering Table [dbo].[tblContentType]...';

GO
ALTER TABLE [dbo].[tblContentType]
    ADD [GroupName] NVARCHAR(50) NULL;

GO
PRINT N'Altering Table [dbo].[tblPropertyDefinitionType]...';

GO
ALTER TABLE [dbo].[tblPropertyDefinitionType]
    ADD [GroupName] NVARCHAR(50) NULL,
        [Hidden] BIT NULL;

GO
PRINT N'Assign GroupName and Hidden to existing rows in tblPropertyDefinitionType...';

GO
UPDATE tblPropertyDefinitionType SET [GroupName] = 'basic', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyBlob';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'basic' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyGuid';

UPDATE tblPropertyDefinitionType SET [GroupName] = 'choice', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyAppSettings';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'choice', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyAppSettingsMultiple';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'choice', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyLanguage';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'choice' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyCheckBoxList';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'choice' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyDropDownList';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'choice' WHERE [Name] = 'Boolean';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'choice' WHERE [Name] = 'Category';

UPDATE tblPropertyDefinitionType SET [GroupName] = 'content', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyContentReferenceList';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'content' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyContentArea';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'content' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyContentAreaItem';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'content' WHERE [Name] = 'ContentReference';

UPDATE tblPropertyDefinitionType SET [GroupName] = 'datetime', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyDateList';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'datetime', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyTimeSpan';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'datetime', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyWeekDay';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'datetime' WHERE [Name] = 'Date';

UPDATE tblPropertyDefinitionType SET [GroupName] = 'link' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyDocumentUrl';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'link' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyImageUrl';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'link' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyLinkCollection';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'link' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyLinkItem';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'link' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyUrl';

UPDATE tblPropertyDefinitionType SET [GroupName] = 'utility', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyColor';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'utility', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyFileSortOrder';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'utility', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertySelector';

UPDATE tblPropertyDefinitionType SET [GroupName] = 'number', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyDoubleList';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'number', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyIntegerList';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'number' WHERE [Name] = 'Number';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'number' WHERE [Name] = 'FloatNumber';

UPDATE tblPropertyDefinitionType SET [GroupName] = 'system', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyFrame';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'system', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyLinkType';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'system', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertySortOrder';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'system', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyVersionStatus';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'system', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyVirtualLink';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'system', [Hidden] = 1 WHERE [Name] = 'PageType';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'system', [Hidden] = 1 WHERE [Name] = 'PageReference';

UPDATE tblPropertyDefinitionType SET [GroupName] = 'text', [Hidden] = 1 WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyStringList';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'text' WHERE [TypeName] = 'EPiServer.SpecializedProperties.PropertyXhtmlString';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'text' WHERE [Name] = 'String';
UPDATE tblPropertyDefinitionType SET [GroupName] = 'text' WHERE [Name] = 'LongString';

GO
PRINT N'Dropping Procedure [dbo].[netContentTypeDelete]...';
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[netContentTypeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
    DROP PROCEDURE [dbo].[netContentTypeDelete];
END

GO
PRINT N'Altering Procedure [dbo].[sp_DatabaseVersion]...';

GO
ALTER PROCEDURE [dbo].[sp_DatabaseVersion]
AS
	RETURN 8018
GO
PRINT N'Update complete.';


GO
